/*
 * Starting poing code for our SIGSCE Nifty Assignments 2005 Submission.
 *
 * (Richard Wicentowski and Tia Newhall)
 * (Thanks to Bruce Maxwell for providing us the orignial tiff to raster 
 *  library routines that we modifed for this library)
 * (2004) 
 */
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <tiffio.h>
#include "tiff.h"



/* For early CS21 experiments, we don't to deal with passing **'s around */


/*
  This routine reads in a TIFF image from "filename" and returns the
  number of columns and number of rows as arguments. The return value
  of the function is a pointer to the image data, which is in
  grayscale format.  The function returns a NULL value if it is unable
  to read in the data.
  */

int gtiff_read2raster(char filename[], unsigned char raster[][COLS]);
int gtiff_read2raster(char filename[], unsigned char raster[][COLS])
{
  TIFF* tif = TIFFOpen(filename, "r");
  if (tif) {
    uint32 columns, rows, r;
    size_t npixels;
    int checkIO;

    TIFFGetField(tif, TIFFTAG_IMAGEWIDTH, &columns);
    TIFFGetField(tif, TIFFTAG_IMAGELENGTH, &rows); 

    if ((columns != COLS) || (rows != ROWS)) {
      fprintf(stderr, "Sorry, this program only works with %d x %d images.\n",
	      COLS, ROWS);
      exit(1);
    }

    npixels = COLS * ROWS;

    if (raster != NULL) {
      for (r = 0, checkIO = 1; ((r < ROWS) && (checkIO == 1)); r++) {
	checkIO = TIFFReadScanline(tif, raster[r], r, 1);
      }
    } else {
      return(-1);
    }
    TIFFClose(tif);
    if (checkIO != 1) {
      return(-1);
    } else {
      return(0);
    }
  } else {
    return (-1);
  }
  return (-1);
}



