/*
 * Starting poing code for our SIGSCE Nifty Assignments 2005 Submission.
 *
 * (Richard Wicentowski and Tia Newhall)
 * (Thanks to Bruce Maxwell for providing us the orignial tiff to raster 
 *  library routines that we modifed for this library)
 * (2004) 
 */
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <tiffio.h>
#include "tiff.h"



/* For early CS1 experiments, we don't to deal with passing **'s around */
/*
  This routine writes an Grayscale TIFF image to "filename" scanline
  by scanline.  The arguments to the function are the filename, the
  raster data in grayscale format, the number of rows, and the number
  of columns.  This function automatically builds the TIFF information
  for a single grayscale image of the given size.
  */

#define INTEL 1
int gtiff_raster2file(char filename[], unsigned char raster[][COLS]);

int gtiff_raster2file(char filename[], unsigned char raster[][COLS])
{
  int r, checkIO;
  TIFF* tif = TIFFOpen(filename, "w");

  if (tif) {
    TIFFSetField(tif, TIFFTAG_IMAGEWIDTH, COLS);
    TIFFSetField(tif, TIFFTAG_IMAGELENGTH, ROWS);
    TIFFSetField(tif, TIFFTAG_BITSPERSAMPLE, 8);
    TIFFSetField(tif, TIFFTAG_SAMPLESPERPIXEL, 1);
    TIFFSetField(tif, TIFFTAG_PHOTOMETRIC, 1);
    TIFFSetField(tif, TIFFTAG_PLANARCONFIG, 1);
    
    for (checkIO = 1, r = 0; ((r < ROWS) && (checkIO == 1)); r++) {
      checkIO = TIFFWriteScanline(tif, raster[r], r, 1);
    }
    TIFFClose(tif);
    if (checkIO != 1) {
      return(-1);
    } else {
      return(0);
    }
  } else {
    TIFFClose(tif);
    return(-1);
  }
  
  return(-1);
}
      

int gtiff_raster2pgmfile(char filename[], unsigned char raster[][COLS]) {

	int in,  out;
	char buf[100];
	int i=0;

	if(gtiff_raster2file("altered.tif", raster) == -1) {
		return -1;
	} else {
		in = open("altered.tif", O_RDONLY);
		out = open(filename,  O_CREAT | O_WRONLY, 00600);
		sprintf(buf, "%s\n%d %d\n%d\n", "P5", ROWS, COLS, 255);
		write(out, buf, strlen(buf));
		while(read(in, buf, 1) == 1) {
			i++;
			// throw away the first 8 bytes
			if(i>8) {
			    write(out, buf, 1);	
			}
		}
		close(in);
		close(out);
	}
	return 0;
}



